;EZUSB, Test 3, using two Data Pointers
#include 8051.h


OEC  .equ   7F9Eh
PINSC .equ  7F9Bh
OUTC .equ   7F98h
DPS  .equ   86h
EP2OUT   .equ 7DC0h
EP2IN    .equ 7E00h
EP2INCS  .equ 7FB8h
EP2INBC  .equ 7FB9h
EP2OUTCS .equ 7FC8h
EP2OUTBC .equ 7FC9h


start mov SP,#80 ; set stack
      mov dptr,#EP2IN ; fill EP2IN buffer with decrementing count
      mov r7,#64
fill  mov a,r7
      movx @dptr,a
      inc dptr
      djnz r7,fill
      ;
      mov r1,#0 ; INS counter
      mov r2,#0 ; OUTS counter
      mov dptr,#EP2INBC
      mov a,#40h
      movx @dptr,a ; arm the IN2 transfer
      ;
loop  mov dptr,#EP2INCS ; Control & Status reg
      movx a,@dptr
      jnb ACC.1,serviceIN2 ; not busyservice it
      mov dptr,#EP2OUTCS
      movx a,@dptr
      jb ACC.1,loop ; busy-keep looping
      ;
serviceOUT2
      inc r2 ; OUT packet counter
      mov dptr,#EP2OUTBC
      movx @dptr,a ; load bc=X to re-arm OUT2
      sjmp loop
      ;
serviceIN2
      inc r1 ; IN packet counter
      mov dptr,#EP2IN
      mov a,r1
      movx @dptr,a ; load IN count into first byte
      inc dptr ; second byte
      mov a,r2
      movx @dptr,a ; load OUT count into second byte
      mov dptr,#EP2INBC
      mov a,#40h
      movx @dptr,a ; load bc=64 to re-arm IN2
      sjmp loop

.end
 